#pragma once

#ifdef _WIN32
#include <winsock2.h>
#else
#include <netinet/in.h>
#endif

#include <unistd.h>
#include <functional>

#define MAX_PENDING 10

namespace Rum::TCP {
class Server {
 private:
  int sock;
  unsigned short port;
  bool stop;

 public:
  Server(unsigned short port);
  virtual ~Server();

  unsigned short get_port() const { return port; }

  void listen(const std::function<void(int, sockaddr_in)>& handler) const;
  virtual void end() {
    stop = true;
#ifdef _WIN32
    shutdown(sock, SD_BOTH);
    closesocket(sock);
#else
    close(sock);
#endif
  }
};
} // namespace Rum::TCP